searchNodes=[{"doc":"Documentation for ExPassword.","ref":"ExPassword.html","title":"ExPassword","type":"module"},{"doc":"See ExPassword.Registry.available_algorithms/0 .","ref":"ExPassword.html#available_algorithms/0","title":"ExPassword.available_algorithms/0","type":"function"},{"doc":"Extracts the options and the algorithm used to generate hash . Returns {:error, :invalid} if hash is invalid or not recognized by available_algorithms/0 .","ref":"ExPassword.html#get_options/1","title":"ExPassword.get_options/1","type":"function"},{"doc":"Hashes password using the given algorithm and options . algorithm has to be a module present in available_algorithms/0 .","ref":"ExPassword.html#hash/3","title":"ExPassword.hash/3","type":"function"},{"doc":"Returns true if the hash has not been issued by algorithm or options are different from the one used to generate hash","ref":"ExPassword.html#needs_rehash?/3","title":"ExPassword.needs_rehash?/3","type":"function"},{"doc":"Checks if password matches the given hash Raises a ExPassword.UnidentifiedAlgorithmError error if any of available_algorithms/0 recognizes hash","ref":"ExPassword.html#verify?/2","title":"ExPassword.verify?/2","type":"function"},{"doc":"This a convenient function which handles ExPassword.verify?/2 and ExPassword.needs_rehash?/3 for you (and takes care of timing attacks) Returns: {:error, :user_is_nil} : if user is nil (not found in your repo, typically after a Repo.get_by/3 operation) {:error, :password_missmatch} : if password does not match the hash in user . field {:ok, []} : if password is correct (matches the hash in user . field ) and does not need to be updated according to algorithm nor options {:ok, a non empty keyword-list} : if password is correct but needs to be updated, meaning the algorithm and/or options extracted from the hash ( user . field ) are different from algorithm and/or options to allow you to then update user 's hash A typical usage would be: # in config/* config :my_app , password_algorithm : ExPassword.Bcrypt , password_options : %{ cost : 11 } algorithm = Application . fetch_env! ( :my_app , :password_algorithm ) options = Application . fetch_env! ( :my_app , :password_options ) user = MyApp.Context.Users . get_user_by ( name : login ) case ExPassword . verify_and_rehash_if_needed ( user , password , algorithm , options ) do { :ok , changes } -&gt; if changes != [ ] do user |&gt; Ecto.Changeset . change ( changes ) |&gt; MyApp.Repo . update! ( ) end # ... (successful authentication) ... { :error , _reason } -&gt; # ... (authentication failed) ... end The case above can even be simplified if at each authentication you do additional updates like the following: case ExPassword . verify_and_rehash_if_needed ( user , password , algorithm , options , [ last_sign_in : DateTime . utc_now ( ) ] ) do { :ok , changes } -&gt; user |&gt; Ecto.Changeset . change ( changes ) |&gt; MyApp.Repo . update! ( ) # ... (successful authentication) ... { :error , _reason } -&gt; # ... (authentication failed) ... end","ref":"ExPassword.html#verify_and_rehash_if_needed/6","title":"ExPassword.verify_and_rehash_if_needed/6","type":"function"},{"doc":"","ref":"ExPassword.html#t:algorithm/0","title":"ExPassword.algorithm/0","type":"type"},{"doc":"Defines an algorithm to be used by ExPassword as a behaviour to be implemented","ref":"ExPassword.Algorithm.html","title":"ExPassword.Algorithm","type":"behaviour"},{"doc":"Callback to extract the options initially used to produce hash from the hash itself Returns {:error, :invalid} if the hash is invalid to the current algorithm else {:ok, options} where options is a Map filled with the values of the options specific to the current hashing method.","ref":"ExPassword.Algorithm.html#c:get_options/1","title":"ExPassword.Algorithm.get_options/1","type":"callback"},{"doc":"Callback to compute the hash of password with the given options (algorithm specific) May raise in case of internal failure or if an option is invalid","ref":"ExPassword.Algorithm.html#c:hash/2","title":"ExPassword.Algorithm.hash/2","type":"callback"},{"doc":"This callback should return true if the options initially used to produce hash are somehow different to options . Its goal is to indicate if the password should be rehashed because these options have since changed, in particular if they are now too weak. Raises if options is invalid","ref":"ExPassword.Algorithm.html#c:needs_rehash?/2","title":"ExPassword.Algorithm.needs_rehash?/2","type":"callback"},{"doc":"Callback to determine if a given hash is valid to the current algorithm. It might be used for validation but its primary purpose is to identify (find) the algorithm from which were generated the given hash.","ref":"ExPassword.Algorithm.html#c:valid?/1","title":"ExPassword.Algorithm.valid?/1","type":"callback"},{"doc":"Callback to check if the provided password matches the reference hash stored_hash May raise in case of internal failure or if stored_hash is invalid","ref":"ExPassword.Algorithm.html#c:verify?/2","title":"ExPassword.Algorithm.verify?/2","type":"callback"},{"doc":"","ref":"ExPassword.Algorithm.html#t:hash/0","title":"ExPassword.Algorithm.hash/0","type":"type"},{"doc":"","ref":"ExPassword.Algorithm.html#t:options/0","title":"ExPassword.Algorithm.options/0","type":"type"},{"doc":"","ref":"ExPassword.Algorithm.html#t:password/0","title":"ExPassword.Algorithm.password/0","type":"type"},{"doc":"Functions to register new algorithms to ExPassword and to know which hashing methods are available.","ref":"ExPassword.Registry.html","title":"ExPassword.Registry","type":"module"},{"doc":"Returns the list of the modules that currently are enabled and provide support to ExPassword for a hashing method","ref":"ExPassword.Registry.html#available_algorithms/0","title":"ExPassword.Registry.available_algorithms/0","type":"function"},{"doc":"Register a new algorithm (a module which implements ExPassword.Algorithm )","ref":"ExPassword.Registry.html#register_algorithm/1","title":"ExPassword.Registry.register_algorithm/1","type":"function"},{"doc":"Returns true if algorithm is currently registered as an active hashing method to ExPassword","ref":"ExPassword.Registry.html#supported_algorithm?/1","title":"ExPassword.Registry.supported_algorithm?/1","type":"function"},{"doc":"","ref":"Mix.Tasks.ExPassword.Check.html","title":"Mix.Tasks.ExPassword.Check","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1 .","ref":"Mix.Tasks.ExPassword.Check.html#run/1","title":"Mix.Tasks.ExPassword.Check.run/1","type":"function"},{"doc":"Exception raised when no suitable algorithm were found from a hash","ref":"ExPassword.UnidentifiedAlgorithmError.html","title":"ExPassword.UnidentifiedAlgorithmError","type":"exception"}]